/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.common.part;

import java.util.Date;
import java.util.List;

import jp.mosp.common.CommonConst;
import jp.mosp.common.part.PartInfo;
import jp.mosp.common.utils.DateUtil;
import jp.mosp.common.utils.VariousUtil;
import jp.mosp.workflow.dao.AmRouteDao;
import jp.mosp.workflow.dao.AmUnitDao;
import jp.mosp.workflow.dto.AmUnitDto;

/**
 * 承認用Partクラス
 * @author yoshida
 *	@version	0.0.2
 */
public class ApprovalPart extends KintaiBasePart {
	
	/**
	 * コンストラクタ
	 */
	public ApprovalPart() {
		super();
	}
	
	/**
	 * コンストラクタ
	 * @param partInfo	Partを利用する際に必要な情報
	 */
	public ApprovalPart(PartInfo partInfo) {
		super(partInfo);
	}
	

	private AmUnitDao	amUnitDao;
	

	/**
	 * 承認用ユニットテーブル用のDAO取得
	 * @return	初期化済みAmUnitDaoインスタンス
	 * @throws Exception 例外処理が発生した場合
	 */
	public AmUnitDao getAmUnitDao() throws Exception {
		if (VariousUtil.isNull(amUnitDao)) {
			amUnitDao = (AmUnitDao)getPreparedDao(AmUnitDao.class.getCanonicalName());
		}
		return amUnitDao;
	}
	

	/**
	 * AmRouteDaoインスタンス
	 */
	private AmRouteDao	amRouteDao;
	

	/**
	 * 承認用ルートテーブル用のDAO取得
	 * @return	初期化済みAmRouteDaoインスタンス
	 * @throws Exception 例外処理が発生した場合
	 */
	public AmRouteDao getAmRouteDao() throws Exception {
		if (VariousUtil.isNull(amRouteDao)) {
			amRouteDao = (AmRouteDao)getPreparedDao(AmRouteDao.class.getCanonicalName());
		}
		return amRouteDao;
	}
	
	/**
	 * 現状承認ユニットコード一覧（AM_UNIT）
	 * @return　現状の承認ユニットコードリスト
	 * @throws Exception 例外処理が発生した場合
	 */
	public String[][] getCurrentUnitArray() throws Exception {
		String targetDate = DateUtil.convDateFormattedByHyphen(DateUtil.getSystemDate());
		// 情報の取得
		List<AmUnitDto> listUnit = getAmUnitDao().findForCurrentUnitArray(targetDate);
		// 配列の作成		
		String[][] aryUnit = new String[listUnit.size()][2];
		for (int i = 0; i < aryUnit.length; i++) {
			aryUnit[i][0] = listUnit.get(i).getUnitCode();
			StringBuffer sb = new StringBuffer();
			sb.append(part().human().getKName(listUnit.get(i).getMain()));
			sb.append(CommonConst.STR_SLASH_SEPARATOR);
			sb.append(part().human().getKName(listUnit.get(i).getAgent()));
			aryUnit[i][1] = sb.toString();
		}
		return aryUnit;
	}
	
	/**
	 * 対象年月日承認ユニット情報取得
	 * @since	0.0.2
	 * @param unitCode		対象ユニットコード
	 * @param kCode			対象社員コード
	 * @param startDate		対象開始年月日
	 * @return	対象年月日承認ユニット情報DTO
	 * @throws Exception 例外処理が発生した場合
	 */
	public AmUnitDto getCurrentUnit(String unitCode, String kCode, String startDate) throws Exception {
		return getAmUnitDao().findForCurrentUnit(unitCode, kCode, startDate);
	}
	
	/**
	 * 対象年月日対象ユニットコード承認者判断
	 * @since	0.0.2
	 * @param unitcode		対象ユニットコード
	 * @param approver		対象承認者社員コード
	 * @param targetDate	対象年月日
	 * @return
	 * <p>
	 * 対象年月日承認ユニット情報DTOがある場合true、そうでない場合false
	 * </p>
	 * @throws Exception 例外処理が発生した場合
	 */
	public boolean isApprover(String unitcode, String approver, Date targetDate) throws Exception {
		return VariousUtil.chkExistDto(getCurrentUnit(unitcode, approver, DateUtil
			.convDateFormattedByHyphen(targetDate)));
	}
	
}
